
#include "config.h"
#include "rtree.h"
#include "cat_rtree.h"
#include "set.h"
#include "disqualify.h"

// does class1 dominate class2?
int isDominate_classOrdering(int classID1, int classID2, mySet *anOrdering)
{
	int i;

	int noOfElt;
	int *elt;

	int eltNo;

	int index1;
	int index2;

	int returnValue;

	noOfElt = anOrdering->noOfElt;
	elt = anOrdering->elt;

	index1 = -1;
	index2 = -1;

	for (i = 0; i < noOfElt; i++)
	{
		eltNo = elt[i];
		if ((index1 == -1) && (eltNo == classID1))
		{
			index1 = i;
		}
		if ((index2 == -1) && (eltNo == classID2))
		{
			index2 = i;
		}
	}

	if ((index1 == -1) || (index2 == -1))
	{
		returnValue = 0;
	}
	else
	{
		if (index1 <= index2)
		{
			returnValue = 1;
		}
		else
		{
			returnValue = 0;
		}
	}

	return returnValue;
}

// does r1 dominate r2?
int isDominate_ordering(record *rec1, record *rec2, int noOfNumAttr, myOrderSet *anOrderSet)
{
	int returnValue;
	int i, j;

	int isEqual;

	int classID1;
	int classID2;

	int isAllEqual;

	int isDominate;

	int dimNo;
	mySet *anOrdering;


	returnValue = 1;

	// compare the numerical attr.
	for (i = 0; i < noOfNumAttr; i++)
	{
		if (rec1->content[i] <= rec2->content[i])
		{
			//returnValue = 1;
		}
		else
		{
			returnValue = 0;
			break;
		}
	}

	// compare the cat. attr (with ordering)
	if (returnValue == 1)
	{
		for (j = 0; j < anOrderSet->noOfElt; j++)
		{
			dimNo = anOrderSet->dimNo[j];
			anOrdering = anOrderSet->orderList[j];

			classID1 = rec1->content[dimNo];
			classID2 = rec2->content[dimNo];

			isDominate = isDominate_classOrdering(classID1, classID2, anOrdering);

			if (isDominate == 1)
			{
				//returnValue = 1;
			}
			else
			{
				returnValue = 0;
			}
		}

		if (returnValue == 1)
		{
			// we need to further check whether it is equal
			isEqual = 1;
			for (i = 0; i < noOfNumAttr; i++)
			{
				if (rec1->content[i] != rec2->content[i])
				{
					isEqual = 0;
					break;
				}
			}

			if (isEqual == 1)
			{
				isAllEqual = 1;
				for (j = 0; j < anOrderSet->noOfElt; j++)
				{
					dimNo = anOrderSet->dimNo[j];
					anOrdering = anOrderSet->orderList[j];

					classID1 = rec1->content[dimNo];
					classID2 = rec2->content[dimNo];

					if (classID1 != classID2)
					{
						isAllEqual = 0;
						break;
					}
				}
				//if (classID1 == classID2)
				if (isAllEqual == 1)
				{
					returnValue = 0;
				}
			}
		}
	}

	

	return returnValue;
}


// classGroup belongs to rec2
// does r1 dominate r2?
int isDominate_ordering_classGroup(record *rec1, record *rec2, myClassSet *classGroup, int noOfNumAttr, myOrderSet *anOrderSet)
{
	int returnValue;
	int i, j, k;

	int isEqual;

	int classID1;
	int classID2;

	int isDominate;
	int isSomeNonDominate;

	int dimNo;

	int orderIndex;

	mySet *list;
	mySet *anOrdering;
//printf("               dimNo               :%d\n", dimNo);
	returnValue = 1;
//printf("       $$$$$ray   1\n");
	// compare the numerical attr.
	for (i = 0; i < noOfNumAttr; i++)
	{
		if (rec1->content[i] <= rec2->content[i])
		{
			//returnValue = 1;
		}
		else
		{
			returnValue = 0;
			break;
		}
	}
//printf("       $$$$$ray   2\n");
	// compare the cat. attr (with ordering)
	if (returnValue == 1)
	{
//printf("       $$$$$ray   2.1\n");
//printf("               dimNo               :%d\n", dimNo);
//printf("               rec1                :%p\n", rec1);
//printf("               rec1->content       :%p\n", rec1->content);
//printf("               rec1->content[dimNo]:%d\n", rec1->content[dimNo]);

		isSomeNonDominate = 0;
		for (j = 0; j < classGroup->noOfElt; j++)
		{
			dimNo = classGroup->dimNo[j];

			orderIndex = -1;
			for (k = 0; k < anOrderSet->noOfElt; k++)
			{
				if (anOrderSet->dimNo[k] == dimNo)
				{
					orderIndex = k;
					break;
				}
			}

			if (orderIndex == -1)
			{
			}
			else
			{
				anOrdering = anOrderSet->orderList[orderIndex];

				classID1 = rec1->content[dimNo];
				//classID2 = rec2->content[dimNo];
		//printf("       $$$$$ray   2.2\n");

				list = classGroup->list[j];

				
				for (i = 0; i < list->noOfElt; i++)
				{
					classID2 = list->elt[i];

					isDominate = isDominate_classOrdering(classID1, classID2, anOrdering);

					if (isDominate == 1)
					{
						//isSomeNonDominate = 0;
						//returnValue = 1;
					}
					else
					{
						isSomeNonDominate = 1;
						break;
						//returnValue = 0;
					}
				}
			}


	//printf("       $$$$$ray   2.3\n");
		}

		if (isSomeNonDominate == 1)
		{
			returnValue = 0;
		}
		else
		{
			returnValue = 1;
		}
//printf("       $$$$$ray   2.4\n");
	}
//printf("       $$$$$ray   3\n");
	if (returnValue == 1)
	{
		// we need to further check whether it is equal
		isEqual = 1;
		for (i = 0; i < noOfNumAttr; i++)
		{
			if (rec1->content[i] != rec2->content[i])
			{
				isEqual = 0;
				break;
			}
		}

		if (isEqual == 1)
		{
			returnValue = 0;
		}
	}
//printf("       $$$$$ray   4\n");
	return returnValue;
}


// does r1 dominate r2?
int isDominate_local(record *rec1, record *rec2, int noOfNumAttr)
{
	int returnValue;
	int i;

	int isEqual;

	returnValue = 1;
	for (i = 0; i < noOfNumAttr; i++)
	{
		if (rec1->content[i] <= rec2->content[i])
		{
			//returnValue = 1;
		}
		else
		{
			returnValue = 0;
			break;
		}
	}

	if (returnValue == 1)
	{
		// we need to further check whether it is equal
		isEqual = 1;
		for (i = 0; i < noOfNumAttr; i++)
		{
			if (rec1->content[i] != rec2->content[i])
			{
				isEqual = 0;
				break;
			}
		}

		if (isEqual == 1)
		{
			returnValue = 0;
		}
	}

	return returnValue;
}

/**
 * Check if two data point has equal numberical value
 */
int isEqual_local(record *rec1, record *rec2, int noOfNumAttr)
{
	int i;
	int isEqual= 1;

	for (i = 0; i < noOfNumAttr; i++)
	{
		if (rec1->content[i] != rec2->content[i])
		{
			isEqual = 0;
			break;
		}
	}

	return isEqual;
}

void global_findGlobalSkylineAndNonSkyline(config *aConfig, projTableWhole *projTabWhole, int noOfNumDim, int dimNo)
{
	int noOfProjTable;
	projTable *projTab;
	int i, j, k, l;

	int noOfData, noOfData2;

	int isKDomJ;
	int isLDomJ;

	int isDomBeforeByOthers;

	record *data;
	int *isMark;

	//int classID;

	record *data2;
	int *isMark2;

	mySet *totalS;

	int index;

	int rtreeClassIndex;

	myClassSet *projDimClass;



	rtreeGroup *anRtreeGroup;

		
	noOfProjTable = projTabWhole->noOfProjTable;
	projTab = projTabWhole->projTab;

	// changed
	if ((aConfig->ALG == 1) || (aConfig->ALG == 2) || (aConfig->ALG == 3) || (aConfig->ALG == 8)  || (aConfig->ALG == 9) || (aConfig->ALG == 10))
	{
		// processing each projected table
		for (i = 0; i < noOfProjTable; i++)
		{
			noOfData = projTab[i].noOfData;

			data = projTab[i].data;
			isMark = projTab[i].isMark;

			// build R-tree on this (projected) data 
			// and then find the skylines 
			// finally, remove the R-tree
			
			// brute force
			for (j = 0; j < noOfData; j++)
			{
				isDomBeforeByOthers = 0;
				for (k = 0; k < noOfData; k++)
				{
					if (j != k)
					{
						isKDomJ = isDominate_local(&(data[k]), &(data[j]), noOfNumDim);
						if (isKDomJ == 1)
						{
							// data[j] is not a skyline (marked with 3)
							isMark[j] = 3;

							isDomBeforeByOthers = 1;

							break;
						}
					}
				}

				if (isDomBeforeByOthers == 0)
				{
					// data[j] is a skyline point locally (marked with 2)
					isMark[j] = 2;
				}
			}
		}
	}
	else 
	{
//printf("~~~~~~~~~~~~ 1\n");
		// build multiple R-tree
		anRtreeGroup = rtree_buildMultipleTreeAndFindLocalSkyline_preprocess(aConfig, projTabWhole);
//printf("~~~~~~~~~~~~ 2\n");
		// find skylines
		for (i = 0; i < noOfProjTable; i++)
		{
			noOfData = projTab[i].noOfData;

			data = projTab[i].data;
			isMark = projTab[i].isMark;

			projDimClass = projTab[i].projDimClass;

			rtreeClassIndex = i;
			//classID = i;

			totalS = set_new();
//printf("~~~~~~~~~~~~ 2.1 (dimNo: %d)\n", dimNo);
//if (i == 1)
//{
//	printf("");
//}
			//projDimClass = classSet_new();
			//classSet_copy(projDimclass, );

			rtree_findSkyline_preprocess(data, aConfig, anRtreeGroup, totalS, dimNo, rtreeClassIndex, projDimClass);

			//classSet_free(projDimClass);
			//free(projDimClass);
//printf("~~~~~~~~~~~~ 2.2\n");
			// marking the points
			// local skyline
			for (j = 0; j < totalS->noOfElt; j++)
			{
				index = totalS->elt[j];
				isMark[index] = 2;
			}
			// non-skyline
			for (j = 0; j < noOfData; j++)
			{
				if (isMark[j] != 2)
				{
					isMark[j] = 3;
				}
			}

			set_free(totalS);
			free(totalS);
		}
//printf("~~~~~~~~~~~~ 3\n");
		// discard R-tree
		discard_rtreeGroup(anRtreeGroup);
		free(anRtreeGroup);
	}
	
	// find the global skylines
	for (i = 0; i < noOfProjTable; i++)
	{
		noOfData = projTab[i].noOfData;

		data = projTab[i].data;
		isMark = projTab[i].isMark;

		// build R-tree on all data (one one R-treee for all classes)
		// and then find the skylines 
		// finally, remove the R-tree

		// brute force
		for (j = 0; j < noOfData; j++)
		{
			if (isMark[j] == 2)
			{
				isDomBeforeByOthers = 0;
				for (k = 0; k < noOfProjTable; k++)
				{
					if (i != k)
					{			
						noOfData2 = projTab[k].noOfData;

						data2 = projTab[k].data;
						isMark2 = projTab[k].isMark;

						for (l= 0; l < noOfData2; l++)
						{
							if ((isMark2[l] == 2) || (isMark2[l] == 1))
							{
								isLDomJ = isDominate_local(&(data2[l]), &(data[j]), noOfNumDim);
								if (isLDomJ == 1)
								{
									// data[j] is not a global skyline 
									// not mark anything

									isDomBeforeByOthers = 1;

									break;
								}
							}
						}
					}

					if (isDomBeforeByOthers == 1)
					{
						break;
					}
				}

				if (isDomBeforeByOthers == 0)
				{
					// data[j] is a global skyilne (marked with 1)
					isMark[j] = 1;
				}
			}
		}
	}
}



myClassSetSetSet *global_findQualifyingCondition(config *aConfig, projTableWhole *projTabWhole, int noOfNumDim, int dimNo)
{
	myClassSetSetSet *returnValue;

	int noOfProjTable;
	projTable *projTab;
	int i, j, k, l;

	int noOfData, noOfData2;

	int isKDomJ;
	int isLDomJ;

	int isDomBeforeByOthers;

	record *data;
	int *isMark;

	//int classID;

	record *data2;
	int *isMark2;

	mySet *totalS;

	int index;

	int rtreeClassIndex;

	myClassSet *projDimClass;

	myClassSet *disqCond;
	myClassSetSet *allDisqCond;

	int *pointID;
	int aPointID;

	int isValid;

	int isContainOrIsWeaker;


	rtreeGroup *anRtreeGroup;

	returnValue = classSetSetSet_new();
	
	noOfProjTable = projTabWhole->noOfProjTable;
	projTab = projTabWhole->projTab;

	// changed
	printf(" ~~~ Phase 1 (processing the projected table...)~~~ \n");
	if ((aConfig->ALG == 1) || (aConfig->ALG == 2) || (aConfig->ALG == 3) || (aConfig->ALG == 4 || aConfig->ALG==5 || aConfig->ALG==6 || aConfig->ALG==7 || aConfig->ALG==8))
	{
		// processing each projected table
		for (i = 0; i < noOfProjTable; i++)
		{
			noOfData = projTab[i].noOfData;

			data = projTab[i].data;
			isMark = projTab[i].isMark;

			// build R-tree on this (projected) data 
			// and then find the skylines 
			// finally, remove the R-tree
			
			// brute force
			for (j = 0; j < noOfData; j++)
			{
				isDomBeforeByOthers = 0;
				for (k = 0; k < noOfData; k++)
				{
					if (j != k)
					{
						isKDomJ = isDominate_local(&(data[k]), &(data[j]), noOfNumDim);
						if (isKDomJ == 1)
						{
							// data[j] is not a skyline (marked with 3)
							isMark[j] = 3;

							isDomBeforeByOthers = 1;

							break;
						}
					}
				}

				if (isDomBeforeByOthers == 0)
				{
					// data[j] is a skyline point locally (marked with 2)
					isMark[j] = 2;
				}
			}
		}
	}
	else 
	{
//printf("~~~~~~~~~~~~ 1\n");
		// build multiple R-tree
		anRtreeGroup = rtree_buildMultipleTreeAndFindLocalSkyline_preprocess(aConfig, projTabWhole);
//printf("~~~~~~~~~~~~ 2\n");
		// find skylines
		for (i = 0; i < noOfProjTable; i++)
		{
			noOfData = projTab[i].noOfData;

			data = projTab[i].data;
			isMark = projTab[i].isMark;

			projDimClass = projTab[i].projDimClass;

			rtreeClassIndex = i;
			//classID = i;

			totalS = set_new();
//printf("~~~~~~~~~~~~ 2.1 (dimNo: %d)\n", dimNo);
//if (i == 1)
//{
//	printf("");
//}
			//projDimClass = classSet_new();
			//classSet_copy(projDimclass, );

			rtree_findSkyline_preprocess(data, aConfig, anRtreeGroup, totalS, dimNo, rtreeClassIndex, projDimClass);

			//classSet_free(projDimClass);
			//free(projDimClass);
//printf("~~~~~~~~~~~~ 2.2\n");
			// marking the points
			// local skyline
			for (j = 0; j < totalS->noOfElt; j++)
			{
				index = totalS->elt[j];
				isMark[index] = 2;
			}
			// non-skyline
			for (j = 0; j < noOfData; j++)
			{
				if (isMark[j] != 2)
				{
					isMark[j] = 3;
				}
			}

			set_free(totalS);
			free(totalS);
		}
//printf("~~~~~~~~~~~~ 3\n");
		// discard R-tree
		discard_rtreeGroup(anRtreeGroup);
		free(anRtreeGroup);
	}
	

	// find the global skylines
	printf(" ~~~ Phase 2 (finding global skylines) ~~~ \n");
	for (i = 0; i < noOfProjTable; i++)
	{
		if (i%100 == 0)
		{
			printf("   %d ...\n", i);
		}
		noOfData = projTab[i].noOfData;

		data = projTab[i].data;
		isMark = projTab[i].isMark;

		pointID = projTab[i].pointID;





		// build R-tree on all data (one one R-treee for all classes)
		// and then find the skylines 
		// finally, remove the R-tree

		// brute force
		for (j = 0; j < noOfData; j++)
		{
			if ((isMark[j] == 2) || (isMark[j] == 1))
			{
				aPointID = pointID[j];

if (aPointID == 172)
{
	printf("");
}

				allDisqCond = classSetSet_new();
				classSetSetSet_insert(returnValue, aPointID, &allDisqCond);

				isDomBeforeByOthers = 0;
				for (k = 0; k < noOfProjTable; k++)
				{
					if (i != k)
					{			
						noOfData2 = projTab[k].noOfData;

						data2 = projTab[k].data;
						isMark2 = projTab[k].isMark;

						for (l= 0; l < noOfData2; l++)
						{
//							printf("%d vs %d\n", i, k);
							if ((isMark2[l] == 2) || (isMark2[l] == 1))
							{
								isLDomJ = isDominate_local(&(data2[l]), &(data[j]), noOfNumDim);
								//Must also include point of equal numerical value
								if (isLDomJ == 1 || isEqual_local(&(data2[l]), &(data[j]), noOfNumDim))
								{
									// data[j] is not a global skyline 
									// not mark anything

									isDomBeforeByOthers = 1;

									//disqCond = getCatClassComparison(aConfig, &(data[j]), &(data2[l]));
									disqCond = getCatClassComparison(aConfig, &(data2[l]), &(data[j]));

									// check whether disCond is valid with respect to the template
									//int CSNode_checkValidOrderingWhole(config *aConfig, mySet *anOrdering)
									isValid = CSNode_checkValidOrderingWhole(aConfig, disqCond);
									if (isValid == 1)
									{

										// further check
//										printf("Add condition to point: %d\n", aPointID);
										isContainOrIsWeaker = classSetSet_isContainOrIsWeaker(allDisqCond, disqCond);

										if (isContainOrIsWeaker == 1)
										{
											// do nothing
										}
										else
										{
											classSetSet_insert(allDisqCond, disqCond);

											classSetSet_removeStronger(allDisqCond, disqCond);
										}
									}
									else
									{
										// do nothing
									}


									//break;
								}
							}
						}
					}

					//if (isDomBeforeByOthers == 1)
					//{
					//	break;
					//}
				}

				if (isDomBeforeByOthers == 0)
				{
					// data[j] is a global skyilne (marked with 1)
					isMark[j] = 1;
				}
			}
		}
	}

	return returnValue;
}



mySet ***global_findLatticeStorageFirst(config *aConfig, projTableWhole *projTabWhole, int noOfNumDim, int dimNo)
{

	mySet ***returnValue;
	int noOfProjTable;
	projTable *projTab;
	int i, j, k, l, m, n;

	int noOfData, noOfData2;

	int isKDomJ;
	int isLDomJ;

	int isDomBeforeByOthers;

	record *data;
	int *isMark;

	//int classID;

	record *data2;
	int *isMark2;

	int *pointID;
	int *pointID2;

	mySet *totalS;

	int index;

	int rtreeClassIndex;

	myClassSet *projDimClass;



	rtreeGroup *anRtreeGroup;

	int noOfClass;

	noOfClass = projTabWhole->noOfProjTable;

	returnValue = (mySet ***) malloc(sizeof(mySet **)*noOfClass);
	for (i = 0; i < noOfClass; i++)
	{
		returnValue[i] = (mySet **) malloc(sizeof(mySet *)*noOfClass);
		for (j = 0; j < noOfClass; j++)
		{
			returnValue[i][j] = set_new();
		}
	}

		
	noOfProjTable = projTabWhole->noOfProjTable;
	projTab = projTabWhole->projTab;

	// changed
	if ((aConfig->ALG == 1) || (aConfig->ALG == 2) || (aConfig->ALG == 3) || (aConfig->ALG == 4))
	{
		// processing each projected table
		for (i = 0; i < noOfProjTable; i++)
		{
			noOfData = projTab[i].noOfData;

			data = projTab[i].data;
			isMark = projTab[i].isMark;

			// build R-tree on this (projected) data 
			// and then find the skylines 
			// finally, remove the R-tree
			
			// brute force
			for (j = 0; j < noOfData; j++)
			{
				isDomBeforeByOthers = 0;
				for (k = 0; k < noOfData; k++)
				{
					if (j != k)
					{
						isKDomJ = isDominate_local(&(data[k]), &(data[j]), noOfNumDim);
						if (isKDomJ == 1)
						{
							// data[j] is not a skyline (marked with 3)
							isMark[j] = 3;

							isDomBeforeByOthers = 1;

							break;
						}
					}
				}

				if (isDomBeforeByOthers == 0)
				{
					// data[j] is a skyline point locally (marked with 2)
					isMark[j] = 2;
				}
			}
		}
	}
	else 
	{
//printf("~~~~~~~~~~~~ 1\n");
		// build multiple R-tree
		anRtreeGroup = rtree_buildMultipleTreeAndFindLocalSkyline_preprocess(aConfig, projTabWhole);
//printf("~~~~~~~~~~~~ 2\n");
		// find skylines
		for (i = 0; i < noOfProjTable; i++)
		{
			noOfData = projTab[i].noOfData;

			data = projTab[i].data;
			isMark = projTab[i].isMark;

			projDimClass = projTab[i].projDimClass;

			rtreeClassIndex = i;
			//classID = i;

			totalS = set_new();
//printf("~~~~~~~~~~~~ 2.1 (dimNo: %d)\n", dimNo);
//if (i == 1)
//{
//	printf("");
//}
			//projDimClass = classSet_new();
			//classSet_copy(projDimclass, );

			rtree_findSkyline_preprocess(data, aConfig, anRtreeGroup, totalS, dimNo, rtreeClassIndex, projDimClass);

			//classSet_free(projDimClass);
			//free(projDimClass);
//printf("~~~~~~~~~~~~ 2.2\n");
			// marking the points
			// local skyline
			for (j = 0; j < totalS->noOfElt; j++)
			{
				index = totalS->elt[j];
				isMark[index] = 2;
			}
			// non-skyline
			for (j = 0; j < noOfData; j++)
			{
				if (isMark[j] != 2)
				{
					isMark[j] = 3;
				}
			}

			set_free(totalS);
			free(totalS);
		}
//printf("~~~~~~~~~~~~ 3\n");
		// discard R-tree
		discard_rtreeGroup(anRtreeGroup);
		free(anRtreeGroup);
	}

	// must be skylines
	for (i = 0; i < noOfProjTable; i++)
	{
		for (k = 0; k < noOfProjTable; k++)
		{
			if (i != k)
			{
				noOfData2 = projTab[k].noOfData;

				data2 = projTab[k].data;
				isMark2 = projTab[k].isMark;

				pointID2 = projTab[k].pointID;

				for (l= 0; l < noOfData2; l++)
				{
					if ((isMark2[l] == 2) || (isMark2[l] == 1))
					{
						set_insert(returnValue[k][i], pointID2[l]);
					}
				}

				// other data points
				for (m = 0; m < noOfProjTable; m++)
				{
					if ((m != k) && (m != i))
					{
						noOfData = projTab[m].noOfData;
						
						data = projTab[m].data;
						isMark = projTab[m].isMark;

						pointID = projTab[m].pointID;

						for (n = 0; n < noOfData; n++)
						{
							if ((isMark[n] == 2) || (isMark[n] == 1))
							{
								set_insert(returnValue[k][i], pointID[n]);
							}
						}
					}
				}
			}
		}
	}
	
	// find the global skylines
	for (i = 0; i < noOfProjTable; i++)
	{
		noOfData = projTab[i].noOfData;

		data = projTab[i].data;
		isMark = projTab[i].isMark;

		pointID = projTab[i].pointID;

		// build R-tree on all data (one one R-treee for all classes)
		// and then find the skylines 
		// finally, remove the R-tree

		// brute force
		for (j = 0; j < noOfData; j++)
		{
			// insert points with class i
			

			if ((isMark[j] == 2) || (isMark[j] == 1))
			{
				isDomBeforeByOthers = 0;
				for (k = 0; k < noOfProjTable; k++)
				{
					if (i != k)
					{	
						// insert all points with class i (when isMark = 2 or isMark = 1)
						//set_insert(returnValue[k][i], pointID2[l]);
						
						noOfData2 = projTab[k].noOfData;

						data2 = projTab[k].data;
						isMark2 = projTab[k].isMark;

						pointID2 = projTab[k].pointID;

						for (l= 0; l < noOfData2; l++)
						{
							if ((isMark2[l] == 2) || (isMark2[l] == 1))
							{
								isLDomJ = isDominate_local(&(data2[l]), &(data[j]), noOfNumDim);
								if (isLDomJ == 1)
								{
									// data[j] is not a global skyline 
									// not mark anything

									isDomBeforeByOthers = 1;

									break;
								}
							}
						}
						if (isDomBeforeByOthers == 1)
						{
							break;
						}
						else
						{
							set_insert(returnValue[k][i], pointID[j]);
						}
					}

					
				}

				if (isDomBeforeByOthers == 0)
				{
					// data[j] is a global skyilne (marked with 1)
					isMark[j] = 1;

					//set_insert(returnValue[k][i], pointID[j]);
				}
			}
		}
	}

	return returnValue;
}


void global_findRemainDAndGlobalSkyline(projTableWhole *projTabWhole, mySet *remainD, mySet *globalSkyline)
{
	int noOfProjTab;
	projTable *projTab;

	int i, j;

	int noOfData;
	record *data;

	int *isMark;

	int eltNo;

	int *pointID;

	noOfProjTab = projTabWhole->noOfProjTable;
	projTab = projTabWhole->projTab;

	for (i = 0; i < noOfProjTab; i++)
	{
		noOfData = projTab[i].noOfData;
		data = projTab[i].data;
		isMark = projTab[i].isMark;
		pointID = projTab[i].pointID;

		for (j = 0; j < noOfData; j++)
		{
			if (isMark[j] == 1)
			{
				// global skyline
				eltNo = pointID[j];
				set_insert(globalSkyline, eltNo);
			}
			else if (isMark[j] == 2)
			{
				eltNo = pointID[j];
				set_insert(remainD, eltNo);
			}
		}
	}
}
