
#ifndef SET_H
#define SET_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include "config.h"

//#include "ordering.h"


#define WORDSIZE 32

struct mySet_s
{
	int noOfElt;
	int *elt;
};

typedef struct mySet_s mySet;

struct mySetSet_s
{
	int noOfElt;
	mySet **elt;
};

typedef struct mySetSet_s mySetSet;


struct myOrderSet_s
{
	int noOfElt;

	int *dimNo;
	mySet **orderList;
};

typedef struct myOrderSet_s myOrderSet;


struct myClassSet_s
{
	int noOfElt;

	int *dimNo;
	mySet **list;
};

typedef struct myClassSet_s myClassSet;

struct myClassSetSet_s
{
	int noOfElt;

	myClassSet **elt;
};

typedef struct myClassSetSet_s myClassSetSet;

struct myClassSetSetSet_s
{
	int noOfElt;

	myClassSetSet **elt;
	int *pointID;
};

typedef struct myClassSetSetSet_s myClassSetSetSet;


mySet *set_new();
void set_copy(mySet *set1, mySet *set2);
void set_insert(mySet *aSet, int no);
void set_remove(mySet *aSet, int index);

void set_union(mySet *set1, mySet *set2);
void set_minus(mySet *set1, mySet *set2);

void set_free(mySet *aSet);

void set_intersection(mySet *set1, mySet *set2);

void set_print(FILE *filePtr, mySet *aSet);
int set_isContain(mySet *aSet, int eltNo);
void set_unionNonRedundant(mySet *set1, mySet *set2);

mySetSet *setset_new();
void setset_insert(mySetSet *aSetSet, mySet **aSet);
void setset_free(mySetSet *aSetSet);
void set_intersection_class(mySet *set1, mySet *set2, mySet *set1Class, mySet *set2Class, int noOfClass, mySet *intersectClass);

myOrderSet *orderSet_new();
void orderSet_insert(myOrderSet *anOrderSet, int dimNo, mySet **anOrdering);
void orderSet_free(myOrderSet *anOrderSet);

myClassSet *classSet_new();

myClassSet *classSet_new();
void classSet_insert(myClassSet *aClassSet, int dimNo, int classID);
void classSet_unionNonRedundant(myClassSet *aClassSet1, myClassSet *aClassSet2);
void classSet_copy(myClassSet *aClassSet1, myClassSet *aClassSet2);
void classSet_free(myClassSet *aClassSet);
int classSet_isContain(myClassSet *aClassSet, int dimNo, int classID);
void classSet_intersection(myClassSet *aClassSet1, myClassSet *aClassSet2);


void orderSet_copy(myOrderSet *anOrderSet1, myOrderSet *anOrderSet2);
void orderSet_freeAll(myOrderSet *anOrderSet);

void orderSet_insertAndUpdate(myOrderSet *anOrderSet, int dimNo, mySet **anOrdering);

int classSet_isContainAll(myClassSet *aClassSet, myClassSet *smallClassSet);

myClassSetSet *classSetSet_new();
//void classSetSet_insert(myClassSetSet *aClassSetSet, int dimNo, int classID);
void classSetSet_free(myClassSetSet *aClassSetSet);
void classSetSet_insert(myClassSetSet *aClassSetSet, myClassSet *aClassSet);
int classSetSet_isContain_set(myClassSetSet *aClassSetSet, myClassSet *aClassSet);

//void classSetSet_insertNonRedundant(myClassSetSet *aClassSetSet, myClassSet **aClassSet);
int classSetSet_insertNonRedundant(myClassSetSet *aClassSetSet, myClassSet **aClassSet);


myClassSetSetSet *classSetSetSet_new();
void classSetSetSet_insert(myClassSetSetSet *aClassSetSetSet, int pointID, myClassSetSet **aClassSetSet);

int classSet_isEqualOrIsWeaker(myClassSet *aClassSet1, myClassSet *aClassSet2);
int classSetSet_isContainOrIsWeaker(myClassSetSet *aClassSetSet, myClassSet *aClassSet);
void classSetSet_removeStronger(myClassSetSet *aClassSetSet, myClassSet *aClassSet);

void set_empty(mySet *aSet);

void classSetSet_clone(myClassSetSet *aClassSetSet1, myClassSetSet *aClassSetSet2);

int classSet_isLessThanOrEqual(myClassSet* aClassSet1, int index1,
		myClassSet* aClassSet2, int index2);

void classSet_print(FILE *filePtr, myClassSet* aClassSet);

int set_isEqual(mySet *aSet1, mySet *aSet2);

void classSet_unionNonRedundant2(myClassSet *aClassSet1, myClassSet *aClassSet2);

void classSet_insertSet(myClassSet *aClassSet, int dimNo, mySet *aSet);

mySet *setSort_union(mySet *set1, mySet *set2);
mySet *setSort_intersect(mySet *set1, mySet *set2);
mySet *setSort_minus(mySet *set1, mySet *set2);
void setSort_insertSort(mySet *set1, int value);
mySet *setSort_union_bulky(mySet *set1, mySet *set2);

#endif
